<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
  <html>
  <body>
    <h1>Bibliography</h1>
    <xsl:apply-templates select="bib/*" />
    <h1>List of co-authors</h1>
    <ul>
    <xsl:for-each select="//author[(. != ../preceding-sibling::*/author)
			  or (. = ../preceding-sibling::*/author)]">

      <xsl:variable name="currentauthor" select="string(self::*)"/>

      <li><xsl:call-template name="displayname">
	  <xsl:with-param name="myelement" select="self::*"/>
	  </xsl:call-template> : 
	<xsl:for-each 
	   select="//author[ . = $currentauthor ]/preceding-sibling::author|following-sibling::author"
	>
	<xsl:call-template name="displayname">
	  <xsl:with-param name="myelement" select="self::*"/>
	</xsl:call-template><xsl:text> </xsl:text>
	</xsl:for-each>
      </li>          
    </xsl:for-each>
    </ul>
    <h1>Sorted list of publishers</h1>
    <xsl:for-each select="//publisher[(. != ../preceding-sibling::*/publisher)
			  or (. = ../preceding-sibling::*/publisher)]">
      <xsl:sort select="."/>
      <xsl:value-of select="."/> <br/>
    </xsl:for-each>
  </body>
  </html>
</xsl:template>

<xsl:template match="book" >
  <h2><xsl:value-of select="title/text()"/></h2>
  <p>
    Year: <xsl:value-of select="@year" /><br/>
    <xsl:choose>     
      <xsl:when test="author">Author</xsl:when>
      <xsl:otherwise>Editor</xsl:otherwise>
    </xsl:choose>
    <xsl:if test="(author|editor)[2]">s</xsl:if>
    :
  <ul><xsl:apply-templates select="author|editor" />
  </ul>
  Publisher: <xsl:value-of select="publisher"/><br/>
  Price: <xsl:value-of select="price"/>$
</p>
</xsl:template>
<xsl:template match="author|editor">
  <li>
  <xsl:call-template name="displayname">
    <xsl:with-param name="myelement" select="self::*"/>
  </xsl:call-template>
  </li>
</xsl:template>
<xsl:template name="displayname">
  <xsl:param name="myelement" select="." />
  <xsl:value-of select="$myelement/first" />
  <xsl:text> </xsl:text>
  <b><xsl:value-of select="$myelement/last"/></b>
</xsl:template>

</xsl:stylesheet>
